package com.xinuxanu.padcatalog
{
	import com.xinuxanu.padcatalog.*;
	
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.filesystem.*;
	import flash.media.Video;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.TextField;
	
	public class BoxInfoCataleg extends Sprite
	{
		public var tb_cat_url:TextField;
		public var tb_cat_version:TextField;
		public var tb_version_disp:TextField;
		public var bt_actualitzar_cat:SimpleButton;
		public var bt_eliminar_cat:SimpleButton;
		
		private var xmlData:XML;
		private var xmlLoader:URLLoader = new URLLoader;
		
		public function BoxInfoCataleg()
		{
			super();
			this.x = 60;
			this.y = 120;
			tb_cat_url.text = String(CatalegInfo.ins().URLCataleg);
			tb_cat_version.text = String(CatalegInfo.ins().versioCataleg);
			tb_version_disp.text = String(CatalegInfo.ins().versioDisp);
			bt_actualitzar_cat.addEventListener(MouseEvent.CLICK,actualitzarCat);
			bt_eliminar_cat.addEventListener(MouseEvent.CLICK,eliminarCat);
			//comprovar nova versió
			if(CatalegInfo.ins().versioDisp<=CatalegInfo.ins().versioCataleg)
			{
				//si no hi ha nova versió ocultem opció actualitzar
				bt_actualitzar_cat.visible = false;
				//resituem bt_eliminar
				bt_eliminar_cat.y = 170;
			}
		}
		private function eliminarCat(e:Event):void
		{
			//abans cal confirmar eliminació!!!!
			var dirCataleg:File = File.documentsDirectory.resolvePath(CatalegInfo.ins().pathDataDirectory);
			dirCataleg.deleteDirectory(true);
			CatalegInfo.ins().cataleg = false;
			trace("Catàleg eliminat.");
			ConfigScreen(parent.parent.parent).changeTab("General");
		}
		private function actualitzarCat(e:Event):void
		{
			var url:String = new String(CatalegInfo.ins().URLCataleg);
			xmlLoader.addEventListener(Event.COMPLETE,xmlComplete);
			xmlLoader.addEventListener(ProgressEvent.PROGRESS,xmlLoading);
			xmlLoader.addEventListener(IOErrorEvent.IO_ERROR,xmlError);
			xmlLoader.load(new URLRequest(url));
		}
		private function xmlComplete(e:Event):void
		{
			trace("URLXML carregada.");
			xmlData = new XML(xmlLoader.data);
			//guardar XML sobreescrivim arxiu existent
			var catalegXMLinfo:File = File.documentsDirectory.resolvePath(CatalegInfo.ins().pathCatalegInfo);
			var fileStream:FileStream = new FileStream;
			fileStream.open(catalegXMLinfo,FileMode.WRITE);
			var XMLString:String = '<?xml version="1.0" encoding="utf-8"?>\n';
			XMLString += xmlData.toXMLString();
			fileStream.writeUTFBytes(XMLString);
			fileStream.close();
			//actualitzem variables locals
			CatalegInfo.ins().versioCataleg = CatalegInfo.ins().versioDisp = xmlData.info.versio;
			//actualitzem la resta de continguts-----------------PENDENT!!!
			//refresquem pantalla
			ConfigScreen(parent.parent.parent).refreshTab();
		}
		private function xmlLoading(e:Event):void
		{
			trace("Carregant URLXML..."); //aquí es podria una barra de càrrega...
		}
		private function xmlError(e:IOErrorEvent):void
		{
			trace("Error: "+e);
			//caldra mostrar un avis de l'error...
		}
	}
}