package com.xinuxanu.padcatalog
{
	import com.xinuxanu.padcatalog.*;
	
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.filesystem.*;
	import flash.net.FileReference;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.text.TextField;
	
	public class BoxNouCataleg extends Sprite
	{
		public var tb_url_cataleg:TextField;
		public var bt_install_cat:SimpleButton;
		
		private var xmlData:XML;
		private var xmlLoader:URLLoader = new URLLoader;
		private var numMedia:int;
		private var mediaArray:Array = new Array;
		private var missError:MessageBox;
		
		private var carregaInfo:CarregaInfo;
		
		private var nomMedia:String;
		
		public function BoxNouCataleg()
		{
			super();
			this.x = 60;
			this.y = 40;
			bt_install_cat.addEventListener(MouseEvent.CLICK,installCat);
		}
		private function installCat(e:Event):void
		{
			trace("Instal·lant cataleg: "+tb_url_cataleg.text);
			//baixa XML
			var url:String = new String(tb_url_cataleg.text);
			xmlLoader.addEventListener(Event.COMPLETE,xmlInfoComplete);
			xmlLoader.addEventListener(ProgressEvent.PROGRESS,xmlLoading);
			xmlLoader.addEventListener(IOErrorEvent.IO_ERROR,urlError);
			xmlLoader.load(new URLRequest(url));
		}
		private function xmlInfoComplete(e:Event):void
		{
			trace("URLXML info Carregada!");
			xmlData = new XML(xmlLoader.data);
			//gurda XML info (info catàleg, pages, categories, elements)
			var catalegXMLinfo:File = File.documentsDirectory.resolvePath(CatalegInfo.ins().pathCatalegInfo);
			var fileStream:FileStream = new FileStream;
			fileStream.open(catalegXMLinfo,FileMode.WRITE);
			var XMLstring:String = '<?xml version="1.0" encoding="utf-8"?>\n';
			XMLstring += xmlData.toXMLString();
			fileStream.writeUTFBytes(XMLstring);
			fileStream.close();
			//carregem el cataleg local
			CatalegInfo.ins().carregaCataleg();
			//mediaArray conté noms de fitxer per baixar...
			var i:int;
			for(i=0;i<xmlData.pages.page.length();i++)//pages
			{
				mediaArray.push(xmlData.pages.page[i].img_page);
			}
			for(i=0;i<xmlData.categories.cat.length();i++)//cats
			{
				mediaArray.push(xmlData.categories.cat[i].cat_img);//imatge fons
				mediaArray.push(xmlData.categories.cat[i].miniature);//imatge miniatura
			}
			for(i=0;i<xmlData.posts.post.length();i++)//elements(posts)
			{
				mediaArray.push(xmlData.posts.post[i].post_img);//imatge de l'element
				mediaArray.push(xmlData.posts.post[i].miniature);//imatge miniatura
				
				if(String(xmlData.posts.post[i].video_poster)!="") { mediaArray.push(xmlData.posts.post[i].video_poster); }//video_poster
				if(xmlData.posts.post[i].video!=""){ mediaArray.push(xmlData.posts.post[i].video); }//vídeo	
				
				if(String(xmlData.posts.post[i].img3D)!="")// imatges 3D si n'hi ha (bucle)...
				{
					var imgName:String = xmlData.posts.post[i].img3D;
					for(var j:int=1;j<61;j++)//60 és el nombre d'imatges que formen el gir 360
					{
						imgName = imgName.substring(0,imgName.lastIndexOf("_"))+"_"+j+".jpg";
						mediaArray.push(imgName);
					}
				}
			}
			mediaArray.push(xmlData.theme.fons_def);//fons per defecte
			mediaArray.push(xmlData.theme.mini_def);//miniatura per defecte
			numMedia = mediaArray.length;	//num total media...
			
			carregaInfo = new CarregaInfo(numMedia+1); //+1 la portada...
			carregaInfo.x = this.width/2 - 150;
			carregaInfo.y = 200;
			this.addChild(carregaInfo);
			//descarregariem continguts... portada i media
			var urlMedia:URLRequest = new URLRequest;
			nomMedia = xmlData.theme.imgportada;//iniciem seqüència amb la portada
			carregaInfo.init(nomMedia);
			urlMedia.url = CatalegInfo.ins().URLCataleg+"wp-content/uploads/"+nomMedia;
			var mediaLoader:URLLoader = new URLLoader;
			mediaLoader.dataFormat = URLLoaderDataFormat.BINARY;
			mediaLoader.addEventListener(ProgressEvent.PROGRESS,carregantMedia);
			mediaLoader.addEventListener(Event.COMPLETE,mediaCarregat);
			mediaLoader.addEventListener(IOErrorEvent.IO_ERROR,mediaError);
			mediaLoader.load(urlMedia);
		}
		private function carregantMedia(e:Event):void
		{
			//trace("carregant..."+e.target.bytesLoaded/e.target.bytesTotal*100);
			carregaInfo.carregant(e.target.bytesLoaded,e.target.bytesTotal);
		}
		private function mediaCarregat(e:Event):void
		{
			trace(nomMedia+" carregat!");
			//guardar vídeo
			var videoFile:File = File.documentsDirectory.resolvePath("PadCatalog/Media/"+nomMedia);
			var fileStream:FileStream = new FileStream;
			fileStream.open(videoFile,FileMode.WRITE);
			fileStream.writeBytes(e.target.data);
			fileStream.close();
			//seguim baixant media si n'hi ha
			if(numMedia!=0)
			{
				numMedia--;
				var urlMedia:URLRequest = new URLRequest;
				nomMedia = mediaArray[numMedia];
				carregaInfo.init(nomMedia);
				urlMedia.url = CatalegInfo.ins().URLCataleg+"wp-content/uploads/"+nomMedia;
				var mediaLoader:URLLoader = new URLLoader;
				mediaLoader.dataFormat = URLLoaderDataFormat.BINARY;
				mediaLoader.addEventListener(ProgressEvent.PROGRESS,carregantMedia);
				mediaLoader.addEventListener(Event.COMPLETE,mediaCarregat);
				mediaLoader.addEventListener(IOErrorEvent.IO_ERROR,mediaError);
				mediaLoader.load(urlMedia);
				
			}else{//no hi ha més media
				ConfigScreen(parent.parent.parent).changeTab("General");
			}
		}
		private function mediaError(e:Event):void
		{
			missError = new MessageBox("Hi ha hagut un error al descarregar media: "+nomMedia,50,200,"error");
			this.addChild(missError);
			trace("Error: "+e);
			//seguim baixant media si n'hi ha
			if(numMedia!=0)
			{
				numMedia--;
				var urlMedia:URLRequest = new URLRequest;
				nomMedia = mediaArray[numMedia];
				carregaInfo.init(nomMedia);
				urlMedia.url = CatalegInfo.ins().URLCataleg+"wp-content/uploads/"+nomMedia;
				var mediaLoader:URLLoader = new URLLoader;
				mediaLoader.dataFormat = URLLoaderDataFormat.BINARY;
				mediaLoader.addEventListener(ProgressEvent.PROGRESS,carregantMedia);
				mediaLoader.addEventListener(Event.COMPLETE,mediaCarregat);
				mediaLoader.addEventListener(IOErrorEvent.IO_ERROR,mediaError);
				mediaLoader.load(urlMedia);
				
			}else{//no hi ha més media
				ConfigScreen(parent.parent.parent).changeTab("General");
			}
		}
		private function xmlLoading(e:Event):void
		{
			trace("Carregant URLXML..."); //aquí es podria una barra de càrrega...
		}
		private function urlError(e:IOErrorEvent):void
		{
			missError = new MessageBox("Hi ha hagut un error al descarregar el nou catàleg.\n\nSembla que la URL indicada no és correcte, o no és accessible. Torna-ho a intentar, o posa't en contacte amb l'administrador.",50,200,"error");
			this.addChild(missError);
			trace("Error: "+e);
		}
	}
}