package com.xinuxanu.padcatalog
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class CatElement extends Sprite
	{
		private var imgLoader:Loader = new Loader;
		private var imgErrCount:int = 0;
		//private var tb_titol:TextField = new TextField;
		private var titolText:TitolText;
		private var tb_text:TextField = new TextField;
		
		private var format:TextFormat = new TextFormat;
		private var fontEugenio:Font = new Eugenio;
		private var fontHelvetica:Font = new HelveticaRegular;
		private var marcTitol:Shape = new Shape;
		private var marcText:Shape = new Shape;
		
		private var mediaContainer:Sprite = new Sprite;
		private var elementImg:String;
		private var elementVideo:String;
		private var elementVideo_poster:String;
		private var element3D:String;
		
		//variables scroll
		private var textScrollRect:Rectangle;
		private var mediaScrollRect:Rectangle;
		private var startY:int;
		private var scrollY:int;
		
		public function CatElement(elementId:String)
		{
			super();
			trace("Element "+elementId+" carrregada");
			//busquem i mostrem element	
			for(var i:int=0;i<CatalegInfo.ins().xmlData.posts.post.length();i++)
			{
				if(CatalegInfo.ins().xmlData.posts.post[i].id == elementId)
				{
					titolText = new TitolText(CatalegInfo.ins().xmlData.posts.post[i].titol);
					//tb_titol.text = CatalegInfo.ins().xmlData.posts.post[i].titol;
					tb_text.htmlText = CatalegInfo.ins().xmlData.posts.post[i].text;
					elementImg = CatalegInfo.ins().xmlData.posts.post[i].post_img;
					elementVideo = CatalegInfo.ins().xmlData.posts.post[i].video;
					elementVideo_poster = CatalegInfo.ins().xmlData.posts.post[i].video_poster;
					element3D = CatalegInfo.ins().xmlData.posts.post[i].img3D;
					
					//busquem img fons categoria
					for(var j:int=0;j<CatalegInfo.ins().xmlData.categories.cat.length();j++)
					{
						if(int(CatalegInfo.ins().xmlData.categories.cat[j].id) == int(CatalegInfo.ins().xmlData.posts.post[i].cat))//sembla que si no ho passem a int no compara bé...?¿
						{
							imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
							imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
							imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
							imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().xmlData.categories.cat[j].cat_img));
						}
					}
				}
			}
		}
		private function imgComplete(e:Event):void
		{
			//mostrem elements
			this.addChildAt(imgLoader,0);
			showTitol();
			showText();
			showMedia();
		}
		private function imgError(e:IOErrorEvent):void
		{
			trace("Error: "+e.text);
			imgErrCount ++;
			if(imgErrCount<2)
			{
				imgLoader = new Loader;
				imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
				imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
				imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
				imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().fonsDefecte));
			}else{
				var fons:Shape = new Shape;
				fons.graphics.beginFill(CatalegInfo.ins().colortext1.color,1);
				fons.graphics.drawRect(0,0,1024,718);
				fons.graphics.endFill();
				this.addChild(fons);
				showTitol();
				showText();
				showMedia();
			}
		}
		private function showTitol():void
		{
			format.size = 30;
			format.font = fontEugenio.fontName;
			format.color = CatalegInfo.ins().colortext1.color;
			//tb_titol.width = 460;
			//tb_titol.x = 10;
			//tb_titol.y = 50;
			//tb_titol.multiline = true;
			//tb_titol.wordWrap = true;
			//this.addChild(tb_titol);
			//tb_titol.setTextFormat(format);
			titolText.x = 10;
			titolText.y = 50;
			this.addChild(titolText);
			//creem marc titol
			marcTitol.graphics.beginFill(CatalegInfo.ins().color1.color,1);
			marcTitol.graphics.drawRect(titolText.x-10,titolText.y-10,480,titolText.height+10);
			marcTitol.graphics.endFill();
			this.addChildAt(marcTitol,this.numChildren-1);
		}
		private function showText():void
		{
			format.size = 18;
			format.font = fontHelvetica.fontName;
			format.color = 0x000000;
			format.leading = 10;
			tb_text.width = 440;
			tb_text.x = 30;
			tb_text.y = 120;
			tb_text.multiline = true;
			tb_text.wordWrap = true;
			this.addChild(tb_text);
			tb_text.setTextFormat(format);
			tb_text.height = tb_text.numLines*28;
			//scroll text
			textScrollRect = new Rectangle(0,0,460,510);
			tb_text.scrollRect = textScrollRect;
			//events scroll
			tb_text.addEventListener(MouseEvent.MOUSE_DOWN,dragText);
			//creem marc text
			marcText.graphics.beginFill(CatalegInfo.ins().colortext1.color,0.75);
			marcText.graphics.drawRect(tb_text.x-10,tb_text.y-10,460,530);
			marcText.graphics.endFill();
			this.addChildAt(marcText,this.numChildren-1);
		}
		private function showMedia():void
		{
			this.addChild(mediaContainer);
			mediaContainer.x = 680;
			var items:Array = new Array;
			var mediaItem:MediaItem;
			if(elementImg!=""){ items.push(mediaItem = new MediaItem("img",elementImg)); }
			if((elementVideo!="")&&(elementVideo_poster!="")){ items.push(mediaItem = new MediaItem("video",elementVideo_poster,elementVideo)); }
			if(element3D!=""){ items.push(mediaItem = new MediaItem("img3D",element3D)); }
			for(var i:int=0;i<items.length;i++)
			{
				mediaContainer.addChild(items[i]);
				items[i].y = i*(240+40)+20;
			}
			//creem scrollRect
			mediaScrollRect = new Rectangle(0,0,470,718);
			mediaContainer.scrollRect = mediaScrollRect;
			//events scroll
			mediaContainer.addEventListener(MouseEvent.MOUSE_DOWN,dragMedia);
		}
		private function imgLoading(e:Event):void
		{
			trace("Loading img: "+imgLoader.contentLoaderInfo.bytesLoaded/imgLoader.contentLoaderInfo.bytesTotal*100+"%");
		}
		//funcions scroll
		private function dragText(e:Event):void
		{
			startY = this.mouseY;
			scrollY = textScrollRect.y;
			this.addEventListener(MouseEvent.MOUSE_MOVE,scrollText);
			this.addEventListener(MouseEvent.MOUSE_UP,dropText);
		}
		private function scrollText(e:Event):void
		{
			if( ( ((this.mouseY-startY)*(-1)+scrollY)>0 ) && ( ((this.mouseY-startY)*(-1))<(tb_text.numLines*28-textScrollRect.height) ) )
			{
				textScrollRect.y = (this.mouseY-startY)*(-1)+scrollY;
				tb_text.scrollRect = textScrollRect;
			}
		}
		private function dropText(e:Event):void
		{
			this.removeEventListener(MouseEvent.MOUSE_MOVE,scrollText);
			this.removeEventListener(MouseEvent.MOUSE_UP,dropText);
		}
		private function dragMedia(e:Event):void
		{
			startY = this.mouseY;
			scrollY = mediaScrollRect.y;
			this.addEventListener(MouseEvent.MOUSE_MOVE,scrollMedia);
			this.addEventListener(MouseEvent.MOUSE_UP,dropMedia);
		}
		private function scrollMedia(e:Event):void
		{
			if( ( ((this.mouseY-startY)*(-1)+scrollY)>0 ) && ( ((this.mouseY-startY)*(-1))<(mediaContainer.numChildren*280+20-mediaScrollRect.height) ) )//mides per controlar...
			{
				mediaScrollRect.y = (this.mouseY-startY)*(-1)+scrollY;
				mediaContainer.scrollRect = mediaScrollRect;
			}
		}
		private function dropMedia(e:Event):void
		{
			this.removeEventListener(MouseEvent.MOUSE_MOVE,scrollMedia);
			this.removeEventListener(MouseEvent.MOUSE_UP,dropMedia);
		}
	}
}