package com.xinuxanu.padcatalog
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class CatPage extends Sprite
	{
		private var imgLoader:Loader = new Loader;
		private var imgErrCount:int = 0;
		private var titolText:TitolText;
		public var tb_page:TextField = new TextField;
		public var format:TextFormat = new TextFormat;
		public var fontHelvetica:Font = new HelveticaRegular;
		public var marcTitol:Shape = new Shape;
		public var marcText:Shape = new Shape;
		
		//variables scroll
		private var textScrollRect:Rectangle;
		private var startY:int;
		private var scrollY:int;
		
		public function CatPage(pageId:String)
		{
			super();
			trace("Pagina "+pageId+" carregada");
			//busquem i mostrem pageId
			for(var i:int=0;i<CatalegInfo.ins().xmlData.pages.page.length();i++)
			{
				if(CatalegInfo.ins().xmlData.pages.page[i].id==pageId)
				{
					titolText = new TitolText(CatalegInfo.ins().xmlData.pages.page[i].titol);
					tb_page.htmlText = CatalegInfo.ins().xmlData.pages.page[i].page_text;
					//carreguem imatge fons
					imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
					imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
					imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
					imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().xmlData.pages.page[i].img_page));
				}
			}
		}
		private function imgLoading(e:Event):void
		{
			trace("Loading img:"+imgLoader.contentLoaderInfo.bytesLoaded/imgLoader.contentLoaderInfo.bytesTotal*100+"%");
		}
		private function imgComplete(e:Event):void
		{
			//mostrem elements...
			this.addChildAt(imgLoader,0);
			showTitol();
			showText();
		}
		private function imgError(e:IOErrorEvent):void
		{
			trace("Error: "+e.text);
			imgErrCount ++;
			if(imgErrCount<2)
			{
				imgLoader = new Loader;
				imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
				imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
				imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
				imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().fonsDefecte));
			}else{
				var fons:Shape = new Shape;
				fons.graphics.beginFill(CatalegInfo.ins().colortext1.color,1);
				fons.graphics.drawRect(0,0,1024,718);
				fons.graphics.endFill();
				this.addChild(fons);
				showTitol();
				showText();
			}
		}
		private function showTitol():void 
		{
			titolText.x = 10;
			titolText.y = 50;
			this.addChild(titolText);
			//creem marc titol
			marcTitol.graphics.beginFill(CatalegInfo.ins().color1.color,1);
			marcTitol.graphics.drawRect(titolText.x-10,titolText.y-10,480,titolText.height+10);
			marcTitol.graphics.endFill();
			this.addChildAt(marcTitol,this.numChildren-1);
		}
		private function showText():void
		{
			format.size = 18;
			format.font = fontHelvetica.fontName;
			format.color = 0x000000;
			format.leading = 10;
			tb_page.width = 460;
			tb_page.x = 520;
			tb_page.y = 50;
			tb_page.multiline = true;
			tb_page.wordWrap = true;
			this.addChild(tb_page);
			tb_page.setTextFormat(format);
			tb_page.height = tb_page.numLines*28;
			//scroll text
			textScrollRect = new Rectangle(0,0,460,630);
			tb_page.scrollRect = textScrollRect;
			//events scroll
			tb_page.addEventListener(MouseEvent.MOUSE_DOWN,dragText);
			//creem marc text
			marcText.graphics.beginFill(CatalegInfo.ins().colortext1.color,0.75);
			marcText.graphics.drawRect(tb_page.x-10,tb_page.y-10,480,650);
			marcText.graphics.endFill();
			this.addChildAt(marcText,this.numChildren-1);
		}
		//funcions scroll text
		private function dragText(e:Event):void
		{
			startY = this.mouseY;
			scrollY = textScrollRect.y;
			this.addEventListener(MouseEvent.MOUSE_MOVE,scrollText);
			this.addEventListener(MouseEvent.MOUSE_UP,dropText);
		}
		private function scrollText(e:Event):void
		{
			if( ( ((this.mouseY-startY)*(-1)+scrollY)>0 ) && ( ((this.mouseY-startY)*(-1))<(tb_page.numLines*28-textScrollRect.height) ) )
			{
				textScrollRect.y = (this.mouseY-startY)*(-1)+scrollY;
				tb_page.scrollRect = textScrollRect;
			}
		}
		private function dropText(e:Event):void
		{
			this.removeEventListener(MouseEvent.MOUSE_MOVE,scrollText);
			this.removeEventListener(MouseEvent.MOUSE_UP,dropText);
		}
	}
}