package com.xinuxanu.padcatalog
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.filesystem.*;
	import flash.geom.ColorTransform;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class CatalegInfo extends Sprite
	{	
		private static var instancia:CatalegInfo;
		public var xmlData:XML;
		private var fileStream:FileStream;	
		private var xmlLoader:URLLoader;
		//Global vars
		public var cataleg:Boolean = false;//flag cataleg local
		public var nomCataleg:String;
		public var URLCataleg:String;
		public var versioCataleg:String;
		public var versioDisp:String;
		//theme cataleg
		public var imgPortada:String;
		public var fonsDefecte:String;
		public var miniaturaDefecte:String;
		public var color1:ColorTransform = new ColorTransform;
		public var colortext1:ColorTransform = new ColorTransform;
		//paths per defecte
		private var _root:File = File.documentsDirectory.resolvePath("PadCatalog");
		public var pathRoot:String = _root.url;
		public var pathDataDirectory:String = "PadCatalog";
		public var pathCatalegInfo:String = "PadCatalog/cataleg_info.xml";
		public var pathCatalegMedia:String = pathRoot+"/Media/";
		
		public function CatalegInfo()
		{
			super();
		}
		public static function ins():CatalegInfo
		{
			if(instancia == null){ instancia = new CatalegInfo; }
			return instancia;
		}
		public function carregaCataleg():void
		{
			var catalegXMLinfo:File = File.documentsDirectory.resolvePath(pathCatalegInfo);
			if(catalegXMLinfo.exists)
			{
				//carreguem info XML local
				fileStream  = new FileStream;
				fileStream.open(catalegXMLinfo, FileMode.READ);//la càrrega ha de ser sincrona per bloquejar el punter d'execució
				xmlData = new XML(fileStream.readUTFBytes(fileStream.bytesAvailable));
				fileStream.close();
				//carraguem info del catàleg local a variables globals
				cataleg = true;
				nomCataleg = xmlData.info.nom;
				versioCataleg = xmlData.info.versio;
				versioDisp = "0.0";//indiquem un versió 0.0 mentre no es comprova si n'hi ha una de nova
				URLCataleg = xmlData.info.url;
				//carreguem variables theme
				color1.color = xmlData.theme.color1;
				colortext1.color = xmlData.theme.colortext1;
				imgPortada = xmlData.theme.imgportada;
				fonsDefecte = xmlData.theme.fons_def;
				miniaturaDefecte = xmlData.theme.mini_def;
			}else{
				//marquem que no hi ha cataleg instal·lat
				cataleg = false;
			}
		}
		public function comprovaVersio():void
		{
			if(cataleg)
			{
				xmlLoader = new URLLoader;
				//events del xmlLoader
				xmlLoader.addEventListener(Event.COMPLETE,xmlComplete);
				xmlLoader.addEventListener(ProgressEvent.PROGRESS,xmlLoading);
				xmlLoader.addEventListener(IOErrorEvent.IO_ERROR,urlError);
				xmlLoader.load(new URLRequest(URLCataleg+"xml"));
			}
		}
		private function xmlComplete(e:Event):void
		{
			trace("URLXML Carregada!");
			xmlData = new XML(xmlLoader.data);
			versioDisp = xmlData.info.versio;
		}
		private function xmlLoading(e:Event):void
		{
			trace("Carregant URLXML..."); //aquí es podria una barra de càrrega...
		}
		private function urlError(e:IOErrorEvent):void
		{
			trace("Error, no s'ha pogut comprovar nova versió. ErrCod: "+e);
			versioDisp = "0.0";//per no deixar la variable en null
		}
	}
}