package com.xinuxanu.padcatalog
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shader;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class Categoria extends Sprite
	{	
		private var idCategoria:String;
		private var imgLoader:Loader = new Loader;
		private var imgErrCount:int = 0;
		private var itemContainer:Sprite = new Sprite;
		private var containerRectScroll:Rectangle;
		
		//public var tb_titol:TextField = new TextField;
		private var titolText:TitolText;
		public var format:TextFormat = new TextFormat;
		public var fontEugenio:Font = new Eugenio;
		public var fontHelvetica:Font = new HelveticaRegular;
		public var marcTitol:Shape = new Shape;
		
		//variables scrolling
		private var startY:int;
		private var scrollY:int;
		
		public function Categoria(catId:String)
		{
			super();
			trace("Categoria "+catId+" carrregada");
			idCategoria = catId;
			//busquem i mostrem CatId
			for(var i:int=0;i<CatalegInfo.ins().xmlData.categories.cat.length();i++)
			{
				if(CatalegInfo.ins().xmlData.categories.cat[i].id==catId)
				{
					titolText = new TitolText(CatalegInfo.ins().xmlData.categories.cat[i].name);
					//tb_titol.text = CatalegInfo.ins().xmlData.categories.cat[i].name;
					//carreguem imatge fons
					imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
					imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
					imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
					imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().xmlData.categories.cat[i].cat_img));
				}
			}
		}
		private function imgLoading(e:Event):void
		{
			trace("Loading img:"+imgLoader.contentLoaderInfo.bytesLoaded/imgLoader.contentLoaderInfo.bytesTotal*100+"%");
		}
		private function imgComplete(e:Event):void
		{
			this.addChildAt(imgLoader,0);
			showCat();
		}
		private function imgError(e:IOErrorEvent):void
		{
			trace("Error: "+e.text);
			imgErrCount ++;
			if(imgErrCount<2)
			{
				imgLoader = new Loader;
				imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
				imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
				imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
				imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().fonsDefecte));
			}else{
				var fons:Shape = new Shape;
				fons.graphics.beginFill(CatalegInfo.ins().colortext1.color,1);
				fons.graphics.drawRect(0,0,1024,718);
				fons.graphics.endFill();
				this.addChild(fons);
				showCat();
			}
		}
		private function showCat():void
		{
			showTitol();
			showItems();
		}
		private function showTitol():void
		{
			format.size = 30;
			format.font = fontEugenio.fontName;
			format.color = CatalegInfo.ins().colortext1.color;
			//tb_titol.width = 460;
			//tb_titol.x = 10;
			//tb_titol.y = 50;
			//tb_titol.multiline = true;
			//tb_titol.wordWrap = true;
			//this.addChild(tb_titol);
			//tb_titol.setTextFormat(format);
			titolText.x = 10;
			titolText.y = 50;
			this.addChild(titolText);
			//creem marc titol
			marcTitol.graphics.beginFill(CatalegInfo.ins().color1.color,1);
			marcTitol.graphics.drawRect(titolText.x-10,titolText.y-10,480,titolText.height+10);
			marcTitol.graphics.endFill();
			this.addChildAt(marcTitol,this.numChildren-1);
		}
		private function showItems():void
		{
			itemContainer.x = 550;
			this.addChild(itemContainer);
			//creem scrollRect
			containerRectScroll =  new Rectangle(0,0,470,718);
			itemContainer.scrollRect = containerRectScroll;
			//events de scroll
			itemContainer.addEventListener(MouseEvent.MOUSE_DOWN,dragList);
			//mostra items cats i/o elements...
			var items:Array = new Array;
			var listItem:ListItem;
			var i:int;
			//afegim items a itemcontainer...
			for(i=0;i<CatalegInfo.ins().xmlData.categories.cat.length();i++)
			{
				if(CatalegInfo.ins().xmlData.categories.cat[i].pare==idCategoria)//cats
				{
					items.push(listItem = new ListItem(CatalegInfo.ins().xmlData.categories.cat[i].id,CatalegInfo.ins().xmlData.categories.cat[i].name,CatalegInfo.ins().xmlData.categories.cat[i].miniature,"categoria"));
					items[items.length-1].y = (items.length-1)*120+20;
					itemContainer.addChild(items[items.length-1]);
				}
			}
			for(i=0;i<CatalegInfo.ins().xmlData.posts.post.length();i++)//elements
			{
				if(CatalegInfo.ins().xmlData.posts.post[i].cat == idCategoria)
				{
					items.push(listItem = new ListItem(CatalegInfo.ins().xmlData.posts.post[i].id,CatalegInfo.ins().xmlData.posts.post[i].titol,CatalegInfo.ins().xmlData.posts.post[i].miniature,"catelement"));
					items[items.length-1].y = (items.length-1)*120+20;
					itemContainer.addChild(items[items.length-1]);
				}
			}
		}		
		//funcions d'events scroll...
		private function dragList(e:Event):void
		{
			startY = this.mouseY;
			scrollY = containerRectScroll.y;
			
			this.addEventListener(MouseEvent.MOUSE_MOVE,scrollList);
			this.addEventListener(MouseEvent.MOUSE_UP,dropList);
		}
		private function scrollList(e:Event):void
		{
			//reposicionar y scrollrect.............L'alçada total del contingut és 120 x item + 20
			if( ( ((this.mouseY-startY)*(-1)+scrollY)>0 ) && ( ((this.mouseY-startY)*(-1))<(itemContainer.numChildren*120+20-containerRectScroll.height) ) )
			{
				containerRectScroll.y = (this.mouseY-startY)*(-1)+scrollY;
				itemContainer.scrollRect = containerRectScroll;
			}		
		}
		private function dropList(e:Event):void
		{
			this.removeEventListener(MouseEvent.MOUSE_MOVE,scrollList);
			this.removeEventListener(MouseEvent.MOUSE_UP,dropList);
		}
	}
}