package com.xinuxanu.padcatalog
{
	import com.greensock.*;
	import com.greensock.easing.*;
	import com.xinuxanu.padcatalog.*;
	
	import flash.display.Sprite;
	
	public class HomeScreen extends Sprite
	{
		public var CatalegContainer:Sprite;
		public var menuNavegacio:MenuNavegacio = new MenuNavegacio;
		
		private var actualPage:String;
		private var pageReference:Sprite;
		private var oldPage:Sprite;
		private var oldId:String;
		private var dirAnim:String;
		
		public function HomeScreen()
		{
			super();
			trace("Home loaded!");
			initHome();
		}
		private function initHome():void
		{
			//Carreguem menu navegacio
			this.addChild(menuNavegacio);
			if(CatalegInfo.ins().cataleg)
			{
				//Carraguem i mostrariem el catàleg local (portada) i menuNav...
				menuNavegacio.getChildAt(2).visible = true;//mostra boto home
				actualPage="portada";
				refreshPage();
				
			}else{//NO hi ha cataleg local, mostrem avis
				menuNavegacio.getChildAt(2).visible = false;//ocultem btHome
				var missatge:MessageBox = new MessageBox("No s'ha trobat cap catàleg instal·lat al dispositiu.\n\nPer a instal·lar un catàleg, vagi a Configuració.",Main._windowWidth/2-250,Main._windowHeight/2-100,"alert");
				CatalegContainer.addChild(missatge);
			}
		}
		//funcions de paginacio del cataleg
		public function changePage(newPage:String,Id:String=null,direccio:String=null):void //parametres: newPage(portada, catpage, categoria, catelement) i Id
		{
			if((newPage!=actualPage)||(oldId!=Id)) //hi ha canvi de pagina...
			{
				actualPage = newPage;
				oldId = Id;
				refreshPage(Id,direccio);
			}	
		}
		private function refreshPage(Id:String=null,direccio:String=null):void //canviem pagina i menu navegacio
		{
			if(pageReference!=null){ oldPage=pageReference; }
			switch(actualPage)
			{
				case "portada":
					pageReference = new Portada;
					menuNavegacio.getChildAt(1).visible = true;
					break;
				case "catpage":
					pageReference = new CatPage(Id);
					menuNavegacio.getChildAt(1).visible = false; 
					break;
				case "categoria":
					pageReference = new Categoria(Id);
					menuNavegacio.getChildAt(1).visible = false; 
					break;
				case "catelement":
					pageReference = new CatElement(Id);
					menuNavegacio.getChildAt(1).visible = false; 
					break;
			}
			menuNavegacio.navegacio(actualPage,Id);//li passarem tipus(actualPage) i Id
			CatalegContainer.addChild(pageReference);
			if(oldPage!=null)
			{
				//animacio de les pagines...
				dirAnim = direccio;
				switch(direccio)
				{
					case "forward":
						oldPage.x = CatalegContainer.x = 0;
						pageReference.x = 1024;
						TweenLite.to(CatalegContainer, 0.75, {x:-1024, ease:Quint.easeOut, onComplete:clearPage});
						break;
					case "back":
						oldPage.x = 1024;
						CatalegContainer.x = -1024;
						pageReference.x = 0;
						TweenLite.to(CatalegContainer, 0.75, {x:0, ease:Quint.easeOut, onComplete:clearPage});
						break;
				}
			}
		}
		private function clearPage():void
		{
			CatalegContainer.removeChild(oldPage);
		}
	}
}