package com.xinuxanu.padcatalog
{
	import com.xinuxanu.padcatalog.*;
	
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.filters.GlowFilter;
	import flash.net.URLRequest;
	
	public class Img3DSlider extends Sprite
	{
		private var sliderWidth:int;
		private var sliderHeight:int;
		private var sliderImgUrl:String;
		private var sliderImgCount:int;
		private var imgContainer:Sprite = new Sprite;
		private var marcSlider:Shape = new Shape;
		private var imgLoader:Loader;
		
		private var btClose:bt_tancar = new bt_tancar;
		
		private var actualImg:int=0;
		private var inicialX:int;
		private var novaImg:int;
		
		public function Img3DSlider(w:int, h:int, imgUrl:String, imgCount:int)
		{
			super();
			sliderWidth = w;
			sliderHeight= h;
			sliderImgUrl = imgUrl;
			sliderImgCount = imgCount;
			//posicionem 3Dslider
			this.x=112
			this.y=59;
			//dibuixem marc
			marcSlider.graphics.beginFill(0xFFFFFF,1);
			marcSlider.graphics.drawRoundRect(-20,-20,w+40,h+40,15);
			marcSlider.graphics.endFill();
			this.addChild(marcSlider);
			//creem filtre sombra al marc
			var sombra:GlowFilter = new GlowFilter;
			sombra.inner = false;
			sombra.color = 0x000000;
			sombra.alpha = 0.6;
			sombra.blurX = sombra.blurY = 100;
			marcSlider.filters = [sombra];
			this.addChild(imgContainer);
			this.addChild(btClose);
			btClose.x = marcSlider.width - 35;
			btClose.y = - 35;
			//carrega images i funcions event
			initSlider();
		}
		private function initSlider():void
		{
			var i:int;
			for(i=1;i<=sliderImgCount;i++)
			{
				imgLoader = new Loader;
				imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgResize);
				imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
				imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
				sliderImgUrl = sliderImgUrl.substring(0,sliderImgUrl.lastIndexOf("_"))+"_"+i+".jpg";
				trace(sliderImgUrl);
				imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+sliderImgUrl));
				imgContainer.addChild(imgLoader);
				imgContainer.getChildAt(i-1).visible = false;
			}
			imgContainer.getChildAt(actualImg).visible = true;
			imgContainer.addEventListener(MouseEvent.MOUSE_DOWN, control3D);
			imgContainer.addEventListener(MouseEvent.MOUSE_UP, unControl3D);
			trace("Slider carregat, url: "+sliderImgUrl+" imatges:"+sliderImgCount)
		}
		private function imgResize(e:Event):void
		{
			var i:int;
			for(i=1;i<=sliderImgCount;i++)
			{
				//resize de tots els fills
				imgContainer.getChildAt(i-1).height = 800*sliderHeight/sliderWidth;
				imgContainer.getChildAt(i-1).width = 800;
			}
		}
		//navegacio pels fills
		private function control3D(e:Event):void
		{
			inicialX=mouseX;
			imgContainer.addEventListener(MouseEvent.MOUSE_MOVE, controlMove);
		}
		private function unControl3D(e:Event):void
		{
			actualImg=novaImg;
			imgContainer.removeEventListener(MouseEvent.MOUSE_MOVE, controlMove);
		}
		private function controlMove(e:Event):void
		{
			novaImg=actualImg+(((mouseX-inicialX)/8)*(-1));//el num de la divisió és la velocitat de gir + petit + ràpid
			if(novaImg>sliderImgCount-1)
			{
				novaImg=actualImg=novaImg-sliderImgCount;
			}else if(novaImg<0)
			{
				novaImg=actualImg=sliderImgCount+novaImg;
			}
			var i:int;
			for(i=1;i<imgContainer.numChildren;i++)
			{
				imgContainer.getChildAt(i).visible = false;
			}
			imgContainer.getChildAt(novaImg).visible = true;
			trace("img"+novaImg);
		}
		private function imgLoading(e:Event):void
		{
			trace("Loading img: "+e.target.loader.contentLoaderInfo.bytesLoaded/e.target.loader.contentLoaderInfo.bytesTotal*100+"%");
		}
		private function imgError(e:IOErrorEvent):void
		{
			trace("Error: "+e.text);
		}
	}
}