package com.xinuxanu.padcatalog
{
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.filters.DropShadowFilter;
	import flash.net.URLRequest;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class ListItem extends Sprite
	{
		private var itemId:String;
		private var itemType:String;
		
		private var imgLoader:Loader = new Loader;
		private var imgErrCount:int = 0;
		private var titolItem:TitolItem;
		private var itemBox:Shape = new Shape;
		private var fontEugenio:Font = new Eugenio;
		
		private var scrollingList:Boolean = false;
		
		public function ListItem(id:String,titol:String,miniatura:String,tipus:String)//rep nom miniatura, text, id i tipus
		{
			super();
			itemId=id;
			itemType=tipus;
			titolItem = new TitolItem(titol);
			
			//this.addEventListener(MouseEvent.CLICK,goTo);
			this.addEventListener(MouseEvent.MOUSE_DOWN,itemTouch);//versio pel dragdrop
			
			//carreguem imgLoader miniatura
			imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
			imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
			imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
			imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+miniatura));
		}
		private function imgComplete(e:Event):void
		{
			this.addChild(imgLoader);
			mostraItem();
		}
		private function imgError(e:IOErrorEvent):void
		{
			trace("Error: "+e.text);
			imgErrCount ++;
			if(imgErrCount<2)
			{
				//carreguem imgLoader miniatura per defecte
				imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
				imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
				imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
				imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+CatalegInfo.ins().miniaturaDefecte));
			}else{
				var fons:Shape = new Shape;
				fons.graphics.beginFill(CatalegInfo.ins().colortext1.color,1);
				fons.graphics.drawRect(0,0,100,100);
				fons.graphics.endFill();
				this.addChild(fons);
				mostraItem();
			}
		}
		private function mostraItem():void
		{
			//afegim elements
			itemBox.graphics.beginFill(CatalegInfo.ins().colortext1.color,1);
			itemBox.graphics.drawRect(0,0,470,100);
			itemBox.graphics.endFill();
			this.addChildAt(itemBox,0);
			titolItem.x = 120;
			titolItem.y = 20;
			this.addChild(titolItem);
			//creem filtre sombra
			var sombra:DropShadowFilter = new DropShadowFilter;
			sombra.distance = 10;
			sombra.color = 0x000000;
			sombra.blurX = sombra.blurY = 10;
			sombra.alpha = 0.5;
			this.filters = [sombra];
		}
		private function imgLoading(e:Event):void
		{
			trace("Loading img:"+imgLoader.contentLoaderInfo.bytesLoaded/imgLoader.contentLoaderInfo.bytesTotal*100+"%");
		}
		private function itemTouch(e:Event):void
		{
			//escoltem si fa scroll abans d'aixecar
			this.addEventListener(MouseEvent.MOUSE_MOVE,scrollList);
			this.addEventListener(MouseEvent.MOUSE_UP,goTo);
		}
		private function scrollList(e:Event):void
		{
			scrollingList = true;
		}
		private function goTo(e:Event):void
		{
			if(scrollingList==false)//comprovem si s'ha fet scroll...
			{
				trace("GoTo: "+itemId+" tipus: "+itemType);
				//cridem gestor de pagines de homescreen...
				HomeScreen(parent.parent.parent.parent).changePage(itemType,itemId,"forward");
			}
			scrollingList = false;//resetejem la variable
			this.removeEventListener(MouseEvent.MOUSE_MOVE,scrollList);
			this.removeEventListener(MouseEvent.MIDDLE_MOUSE_UP,goTo);
		}
	}
}