package com.xinuxanu.padcatalog
{
	import com.greensock.*;
	import com.greensock.easing.*;
	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	
	public class Main extends MovieClip
	{
		public var preloader:PreLoader;
		
		public var ScreenContainer:Sprite;
		private var actualScreen:String;
		private var screenReference:Sprite;
		private var oldScreen:Sprite;
		
		//Global vars
		public static var _windowHeight:int;
		public static var _windowWidth:int;
		
		public function Main()
		{
			super();
			trace("Hey ho, let's go!");
			_windowHeight = stage.stageHeight;
			_windowWidth = stage.stageWidth;
			
			//iniciant preloader
			preloader = new PreLoader();
			addChild(preloader);
			preloader.initLoader("Carregant App...");
			stop();
			this.addEventListener(Event.ENTER_FRAME,loadingApp);
		}
		private function loadingApp(e:Event):void
		{
			var loaded:Number = stage.loaderInfo.bytesLoaded;
			var total:Number = stage.loaderInfo.bytesTotal;
			if(loaded==total)//Tot carregat
			{
				removeEventListener(Event.ENTER_FRAME, loadingApp);
				removeChild(preloader);
				trace("App carregada");
				//iniciem App
				gotoAndStop("INIT");
				initApp();
			}else{//Carregant
				preloader.percentLoader(Math.floor(loaded/total*100));
				trace(loaded+"/"+total);
			}
		}
		private function initApp():void
		{
			//Comprobem cataleg local i versió a internet
			CatalegInfo.ins().carregaCataleg();
			CatalegInfo.ins().comprovaVersio();
			//mostrem pantalla home
			actualScreen = "home";
			refreshScreen();
		}
		public function changeScreen(newScreen:String):void
		{
			if(newScreen!=actualScreen)
			{
				actualScreen = newScreen;
				refreshScreen();
			}
		}
		private function refreshScreen():void
		{
			if(screenReference!=null){ oldScreen=screenReference; }
			switch(actualScreen)
			{
				case "home": screenReference = new HomeScreen; break;
				case "config": screenReference = new ConfigScreen; break;
			}
			ScreenContainer.addChild(screenReference);
			//animació del ScreenContainer si hi havia una altre pantalla
			if(oldScreen!=null)
			{
				switch(actualScreen)
				{
					case "home": 
						screenReference.y = 0;
						TweenLite.to(ScreenContainer, 0.75, {y:0, ease:Quint.easeOut, onComplete:clearScreen}); 
						break;
					case "config":
						screenReference.y = -768;
						TweenLite.to(ScreenContainer, 0.75, {y:768, ease:Quint.easeOut, onComplete:clearScreen}); 
						break;
				}
			}
		}
		private function clearScreen():void
		{
			ScreenContainer.removeChild(oldScreen)
		}
	}
}