package com.xinuxanu.padcatalog
{
	import com.xinuxanu.padcatalog.Img3DSlider;
	
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.filters.DropShadowFilter;
	import flash.net.URLRequest;
	
	public class MediaItem extends Sprite
	{
		private var mediaType:String;
		private var mediaUrl:String;
		private var vidUrl:String;
		
		private var imgLoader:Loader = new Loader;
		private var marc:Shape = new Shape;
		
		private var scollingMedia:Boolean = false;
		
		public function MediaItem(tipus:String,url:String,videoUrl:String=null)//potser ha de rebre un parametre més pels vídeos
		{
			super();
			mediaType = tipus;
			mediaUrl = url;
			vidUrl = videoUrl;
			this.addEventListener(MouseEvent.MOUSE_DOWN,touchItem);
			imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,imgComplete);
			imgLoader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,imgLoading);
			imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,imgError);
			imgLoader.load(new URLRequest(CatalegInfo.ins().pathCatalegMedia+url));
		}
		private function imgComplete(e:Event):void
		{
			//faltarà afegir un distintiu per cada tipus media...
			imgLoader.height = 320*imgLoader.height/imgLoader.width;
			imgLoader.width = 320;
			marc.graphics.beginFill(CatalegInfo.ins().colortext1.color,1);
			marc.graphics.drawRect(-10,-10,imgLoader.width+20,imgLoader.height+20);
			marc.graphics.endFill();
			this.addChild(marc);
			this.addChild(imgLoader);
			var sombra:DropShadowFilter = new DropShadowFilter;
			sombra.distance = 10;
			sombra.color = 0x000000;
			sombra.blurX = sombra.blurY = 10;
			sombra.alpha = 0.5;
			this.filters = [sombra];
		}
		private function touchItem(e:Event):void
		{
			this.addEventListener(MouseEvent.MOUSE_MOVE,scrollMedia);
			this.addEventListener(MouseEvent.MOUSE_UP,mostraMedia);
		}
		private function scrollMedia(e:Event):void
		{
			scollingMedia = true;
		}
		private function mostraMedia(e:Event):void
		{
			if((scollingMedia==false)&&(CatElement(parent.parent).numChildren<8))//controlem també que només es mostra un media...
			{
				trace("GoTo: "+mediaUrl+" tipus "+mediaType);
				trace("Fils:"+CatElement(parent.parent).numChildren);
				
				switch(mediaType)
				{
					case "img":
						var elementImg:ElementImg = new ElementImg(mediaUrl);
						CatElement(parent.parent).addChild(elementImg);
						break;
					case "video":
						var elementVideo:ElementVideo = new ElementVideo(vidUrl);
						CatElement(parent.parent).addChild(elementVideo);
						break;
					case "img3D":
						var imgSlider:Img3DSlider = new Img3DSlider(800,600,mediaUrl,60);
						CatElement(parent.parent).addChild(imgSlider);
						break;
				}
			}
			scollingMedia = false;
			this.removeEventListener(MouseEvent.MOUSE_MOVE,scrollMedia);
			this.removeEventListener(MouseEvent.MOUSE_UP,mostraMedia);
		}
		private function imgLoading(e:Event):void
		{
			trace("Loading img: "+imgLoader.contentLoaderInfo.bytesLoaded/imgLoader.contentLoaderInfo.bytesTotal*100+"%");
		}
		private function imgError(e:IOErrorEvent):void
		{
			trace("Error: "+e.text);
		}
	}
}